import { h, Component } from 'preact';
import WBNavbarCommon from 'wb-navbar-common';
import WBArvadosCrumbs from 'wb-arvados-crumbs';
import WBCommonFields from 'wb-common-fields';
import WBContainerFields from 'wb-container-fields';
import WBLiveLogs from 'wb-live-logs';

class WBContainerView extends Component {
  render({ app, uuid }) {
    return (
      <div>
        <WBNavbarCommon app={ app } />

        <WBArvadosCrumbs app={ app } uuid={ uuid } />

        <div class="my-2">
          This is the container view for { uuid }
        </div>

        <h2>Common Fields</h2>
        <WBCommonFields app={ app } uuid={ uuid } />

        <h2>Container Fields</h2>
        <WBContainerFields app={ app } uuid={ uuid } />

        <h2>Live Logs</h2>
        <WBLiveLogs app={ app } uuid={ uuid } />
      </div>
    );
  }
}

export default WBContainerView;
